GIT-DIFF-FILES(1)

NAME
git-diff-files - Compares files in the working tree and the index

SYNOPSIS
git-diff-files [-q] [-0|-1|-2|-3|-c|--cc] [<common diff options>] [<path>...].sp

DESCRIPTION
Compares the files in the working tree and the index. When paths are specified, compares only those named paths. Otherwise all entries in the index are compared. The output format is the same as "git-diff-index" and "git-diff-tree"..sp

OPTIONS

-p  Generate patch (see section on generating patches)

-u  Synonym for "-p".

--patch-with-raw
    Generate patch but keep also the default raw diff output.

--stat
    Generate a diffstat instead of a patch.

--summary
    Output a condensed summary of extended header information such as creations, renames and mode changes.

--patch-with-stat
    Generate patch and prepend its diffstat.

-z  \0 line termination on output

--name-only
    Show only names of changed files.

--name-status
    Show only names and status of changed files.

--full-index
    Instead of the first handful characters, show full object name of pre- and post-image blob on the "index" line when generating a patch format output.

--abbrev[=<n>]
    Instead of showing the full 40-byte hexadecimal object name in diff-raw format output and diff-tree header lines, show only handful hexdigits prefix. This is independent of --full-index option above, which controls the diff-patch output format. Non default number of digits can be specified with --abbrev=<n>.

-B  Break complete rewrite changes into pairs of delete and create.

-M  Detect renames.

-C  Detect copies as well as renames.

--diff-filter=[ACDMRTUXB*]
    Select only files that are Added (A), Copied (C), Deleted (D), Modified (M), Renamed (R), have their type (mode) changed (T), are Unmerged (U), are Unknown (X), or have had their pairing Broken (B). Any combination of the filter characters may be used. When * (All-or-none) is added to the combination, all paths are selected if there is any file that matches other criteria in the comparison; if there is no file that matches other criteria, nothing is selected.

--find-copies-harder
    For performance reasons, by default, -C option finds copies only if the original file of the copy was modified in the same changeset. This flag makes the command inspect unmodified files as candidates for the source of copy. This is a very expensive operation for large projects, so use it with caution.

-l<num>
    -M and -C options require O(n^2) processing time where n is the number of potential rename/copy targets. This option prevents rename/copy detection from running if the number of rename/copy targets exceeds the specified number.

-S<string>
    Look for differences that contain the change in <string>.

--pickaxe-all
    When -S finds a change, show all the changes in that changeset, not just the files that contain the change in <string>.

--pickaxe-regex
    Make the <string> not a plain string but an extended POSIX regex to match.

-O<orderfile>
    Output the patch in the order specified in the <orderfile>, which has one shell glob pattern per line.

-R  Swap two inputs; that is, show differences from index or on-disk file to tree contents. For more detailed explanation on these common options, see also [1]diffcore documentation..sp

-1 -2 -3 or --base --ours --theirs, and -0
    Diff against the "base" version, "our branch" or "their branch" respectively. With these options, diffs for merged entries are not shown.

    The default is to diff against our branch (-2) and the cleanly resolved paths. The option -0 can be given to omit diff output for unmerged entries and just show "Unmerged".

-c,--cc
    This compares stage 2 (our branch), stage 3 (their branch) and the working tree file and outputs a combined diff, similar to the way diff-tree shows a merge commit with these flags.

-q  Remain silent even on nonexisting files

OUTPUT FORMAT
The output format from "git-diff-index", "git-diff-tree" and "git-diff-files" are very similar..sp These commands all compare two sets of things; what is compared differs:.sp

git-diff-index <tree-ish>
    compares the <tree-ish> and the files on the filesystem.

git-diff-index --cached <tree-ish>
    compares the <tree-ish> and the index.

git-diff-tree [-r] <tree-ish-1> <tree-ish-2> [<pattern>...]
    compares the trees named by the two arguments.

git-diff-files [<pattern>...]
    compares the index and the files on the filesystem. An output line is formatted this way:.sp

    in-place edit  :100644 100644 bcd1234... 0123456... M file0
    copy-edit      :100644 100644 abcd123... 1234567... C68 file1 file2
    rename-edit    :100644 100644 abcd123... 1234567... R86 file1 file3
    create         :000000 100644 0000000... 1234567... A file4
    delete         :100644 000000 1234567... 0000000... D file5
    unmerged       :000000 000000 0000000... 0000000... U file6
That is, from the left to the right:.sp

1.  a colon.

2.  mode for "src"; 000000 if creation or unmerged.

3.  a space.

4.  mode for "dst"; 000000 if deletion or unmerged.

5.  a space.

6.  sha1 for "src"; 0{40} if creation or unmerged.

7.  a space.

8.  sha1 for "dst"; 0{40} if creation, unmerged or "look at work tree".

9.  a space.

10. status, followed by optional "score" number.

11. a tab or a NUL when -z option is used.

12. path for "src"

13. a tab or a NUL when -z option is used; only exists for C or R.

14. path for "dst"; only exists for C or R.

15. an LF or a NUL when -z option is used, to terminate the record.

<sha1> is shown as all 0's if a file is new on the filesystem and it is out of sync with the index..sp Example:.sp

    :100644 100644 5be4a4...... 000000...... M file.c
When -z option is not used, TAB, LF, and backslash characters in pathnames are represented as \t, and \\, respectively..sp

GENERATING PATCHES WITH -P
When "git-diff-index", "git-diff-tree", or "git-diff-files" are run with a -p option, they do not produce the output described above; instead they produce a patch file..sp The patch generation can be customized at two levels..sp

1.  When the environment variable GIT_EXTERNAL_DIFF is not set, these commands internally invoke "diff" like this:

    diff -L a/<path> -L b/<path> -pu <old> <new>
For added files, /dev/null is used for <old>. For removed files, /dev/null is used for <new>

The "diff" formatting options can be customized via the environment variable GIT_DIFF_OPTS. For example, if you prefer context diff:

    GIT_DIFF_OPTS=-c git-diff-index -p HEAD

2.  When the environment variable GIT_EXTERNAL_DIFF is set, the program named by it is called, instead of the diff invocation described above.

    For a path that is added, removed, or modified, GIT_EXTERNAL_DIFF is called with 7 parameters:

    path old-file old-hex old-mode new-file new-hex new-mode
where:
<old|new>-file | are files GIT_EXTERNAL_DIFF can use to read the contents of <old|new>,
<old|new>-hex | are the 40-hexdigit SHA1 hashes,
<old|new>-mode | are the octal representation of the file modes.

The file parameters can point at the user's working file (e.g. new-file in "git-diff-files"), /dev/null (e.g. old-file when a new file is added), or a temporary file (e.g. old-file in the index). GIT_EXTERNAL_DIFF should not worry about unlinking the temporary file --- it is removed when GIT_EXTERNAL_DIFF exits.

For a path that is unmerged, GIT_EXTERNAL_DIFF is called with 1 parameter, <path>..sp

GIT SPECIFIC EXTENSION TO DIFF FORMAT
What -p option produces is slightly different from the traditional diff format..sp

1.  It is preceded with a "git diff" header, that looks like this:

    diff --git a/file1 b/file2
The a/ and b/ filenames are the same unless rename/copy is involved. Especially, even for a creation or a deletion, /dev/null is _not_ used in place of a/ or b/ filenames.

When rename/copy is involved, file1 and file2 show the name of the source file of the rename/copy and the name of the file that rename/copy produces, respectively.

2.  It is followed by one or more extended header lines:

    old mode <mode>
    new mode <mode>
    deleted file mode <mode>
    new file mode <mode>
    copy from <path>
    copy to <path>
    rename from <path>
    rename to <path>
    similarity index <number>
    dissimilarity index <number>
    index <hash>..<hash> <mode>

3.  TAB, LF, and backslash characters in pathnames are represented as \t, and \\, respectively.

COMBINED DIFF FORMAT
git-diff-tree and git-diff-files can take -c or --cc option to produce combined diff, which looks like this:.sp

    diff --combined describe.c
    @@@ +98,7 @@@
       return (a_date > b_date) ? -1 : (a_date == b_date) ? 0 : 1;
      }
    - static void describe(char *arg)
     -static void describe(struct commit *cmit, int last_one)
    ++static void describe(char *arg, int last_one)
      {
     +     unsigned char sha1[20];
     +     struct commit *cmit;
Unlike the traditional unified diff format, which shows two files A and B with a single column that has - (minus — appears in A but removed in B), + (plus — missing in A but added to B), or (space — unchanged) prefix, this format compares two or more files file1, file2,... with one file X, and shows how X differs from each of fileN. One column for each of fileN is prepended to the output line to note how X's line is different from it..sp A - character in the column N means that the line appears in fileN but it does not appear in the last file. A + character in the column N means that the line appears in the last file, and fileN does not have that line..sp In the above example output, the function signature was changed from both files (hence two - removals from both file1 and file2, plus ++ to mean one line that was added does not appear in either file1 nor file2). Also two other lines are the same from file1 but do not appear in file2 (hence prefixed with +)..sp When shown by git diff-tree -c, it compares the parents of a merge commit with the merge result (i.e. file1..fileN are the parents). When shown by git diff-files -c, it compares the two unresolved merge parents with the working tree file (i.e. file1 is stage 2 aka "our version", file2 is stage 3 aka "their version")..sp

AUTHOR
Written by Linus Torvalds <torvalds@osdl.org>.sp

DOCUMENTATION
Documentation by David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>..sp

GIT
Part of the git(7) suite.sp

REFERENCES

1. diffcore documentation
    diffcore.html